
#include "TBbuild.h"

static inline uint64 Attacks (typePOS *POSITION, int pi, int sq)
{if (pi>7) pi-=7; if (pi==2) return AttN[sq]; if (pi==3) return AttB(sq);
 if (pi==4) return AttR(sq); if (pi==5) return AttQ(sq);
 if (pi==6) return AttK[sq]; return 0ULL;}

#define FIFTH_RANK 0x000000ff00000000ULL
int GenMoveListBlack (typePOS *POS,uint16 *ml,uint64 *EP)
{int j, p, sq, to, ep = POS->DYN->ep; uint16 *u = ml; uint64 T, U;
 *EP = 0; *ml = 0; if (!bBitboardOcc) return 0;
#if 1
 if (ep)
 {if (FILE (ep) != FH && POS->sq[ep + 9] == bEnumP)
     *ml++ = FlagEP | ((ep + 9) << 6) | (ep);
   if (FILE (ep) != FA && POS->sq[ep + 7] == bEnumP)
     *ml++ = FlagEP | ((ep + 7) << 6) | (ep);}
#endif
 T = ((bBitboardP & ~FILEa) >> 9) & wBitboardOcc;
 while (T)
 {to = BSF (T); T &= (T - 1);
  if (to >= A2) *ml++ = ((to + 9) << 6) | (to);
  else for (p = 9; p <= 13; p++) *ml++ = ((p-7)<<12) | ((to + 9) << 6) | (to);}
 T = ((bBitboardP & ~FILEh) >> 7) & wBitboardOcc;
 while (T)
 {to = BSF (T); T &= (T - 1);
  if (to >= A2) *ml++ = ((to + 7) << 6) | (to);
  else for (p = 9; p <= 13; p++) *ml++ = ((p-7)<<12) | ((to + 7) << 6) | (to);}
 for (j = 9; j <= 13; j++) for (U = POSITION->bitboard[j]; U; U &= (U - 1))
 {sq = BSF (U);  T = Attacks (POS, j, sq) & wBitboardOcc;
  while (T) { to = BSF (T); T &= (T - 1); *ml++ = (sq << 6) | (to);}}
 (*ml) = 0; if (ml != u) return ml - u;
 T=(bBitboardP>>8)&~POS->OCCUPIED; U=(T>>8)&~POS->OCCUPIED&FIFTH_RANK;
 while (T)
 {to = BSF (T); T &= (T - 1);
  if (to >= A2) *ml++ = ((to + 8) << 6) | (to);
  else for (p = 9; p <= 13; p++) *ml++ = ((p-7)<<12) | ((to + 8) << 6) | (to);}
 *EP=U&(((wBitboardP&FIFTH_RANK)<<1)|((wBitboardP&FIFTH_RANK)>>1));
 while (U) { to = BSF (U); U &= (U - 1); *ml++ = ((to + 16) << 6) | (to);}
 for (j = 9; j <= 13; j++) for (U = POSITION->bitboard[j]; U; U &= (U - 1))
 {sq = BSF (U); T = Attacks (POS, j, sq) & ~POS->OCCUPIED;
  while (T) { to = BSF (T); T &= (T - 1); *ml++ = (sq << 6) | (to);}}
 (*ml) = 0; return ml - u;}

#define FOURTH_RANK 0x00000000ff000000ULL
int GenMoveList (typePOS *POS,uint16 *ml,uint64 *EP)
{int j, p, sq, to, ep = POS->DYN->ep; uint16 *u = ml; uint64 T, U;
 if (!POS->wtm) return GenMoveListBlack(POS,ml,EP);
 *EP = 0; *ml = 0; if (!wBitboardOcc) return 0;
 if (ep)
 {if (FILE (ep) != FA && POS->sq[ep - 9] == wEnumP)
     *ml++ = FlagEP | ((ep - 9) << 6) | (ep);
   if (FILE (ep) != FH && POS->sq[ep - 7] == wEnumP)
     *ml++ = FlagEP | ((ep - 7) << 6) | (ep);}
 T = ((wBitboardP & ~FILEa) << 7) & bBitboardOcc;
 while (T)
 {to = BSF (T); T &= (T - 1);
  if (to < A8) *ml++ = ((to - 7) << 6) | (to);
  else for (p = 2; p <= 6; p++) *ml++ = (p << 12) | ((to - 7) << 6) | (to);}
 T = ((wBitboardP & ~FILEh) << 9) & bBitboardOcc;
 while (T)
 {to = BSF (T); T &= (T - 1);
  if (to < A8) *ml++ = ((to - 9) << 6) | (to);
  else for (p = 2; p <= 6; p++) *ml++ = (p << 12) | ((to - 9) << 6) | (to);}
 for (j = 2; j <= 6; j++) for (U = POSITION->bitboard[j]; U; U &= (U - 1))
 {sq = BSF (U);  T = Attacks (POS, j, sq) & bBitboardOcc;
  while (T) { to = BSF (T); T &= (T - 1); *ml++ = (sq << 6) | (to);}}
 (*ml) = 0; if (ml != u) return ml - u;
 T=(wBitboardP<<8)&~POS->OCCUPIED; U=(T<<8)&~POS->OCCUPIED&FOURTH_RANK;
 while (T)
 {to = BSF (T); T &= (T - 1);
  if (to < A8) *ml++ = ((to - 8) << 6) | (to);
  else for (p = 2; p <= 6; p++) *ml++ = (p << 12) | ((to - 8) << 6) | (to);}
 *EP=U&(((bBitboardP&FOURTH_RANK)<<1)|((bBitboardP&FOURTH_RANK)>>1));
 while (U) { to = BSF (U); U &= (U - 1); *ml++ = ((to - 16) << 6) | (to);}
 for (j = 2; j <= 6; j++) for (U = POSITION->bitboard[j]; U; U &= (U - 1))
 {sq = BSF (U); T = Attacks (POS, j, sq) & ~POS->OCCUPIED;
  while (T) { to = BSF (T); T &= (T - 1); *ml++ = (sq << 6) | (to);}}
 (*ml) = 0; return ml - u;}

#define DEBUG 0
uint32 MakePiSqCap(type_PiSq *PiSq,uint16 mv) // must be a cap, not ep
{uint32 u; uint8 to=TO(mv),from=FROM(mv); int f,t,k;
 if (DEBUG) {printf("MAKE1 "); DUMP_PISQ(PiSq);}
 for (k=0;k<PiSq->n;k++) // TODO BlockedPawn
 {if (PiSq->sq[k]==from) f=k; if (PiSq->sq[k]==to) t=k;}
 u=mv|(PiSq->pi[t]<<16);
 PiSq->sq[f]=to; if (mv>>12) PiSq->pi[f]=(mv>>12)+7*!PiSq->wtm;
 PiSq->sq[t]=PiSq->sq[PiSq->n-1]; PiSq->pi[t]=PiSq->pi[PiSq->n-1];
 PiSq->sq[PiSq->n-1]=PiSq->pi[PiSq->n-1]=0;
 PiSq->n--; PiSq->wtm^=1;
 PiSq->pawn=FALSE;
 for (k=0;k<PiSq->n;k++)
   if (PiSq->pi[k]==wEnumP || PiSq->pi[k]==bEnumP || PiSq->pi[k]==BlockedPawn)
     PiSq->pawn=TRUE;
 if (DEBUG) {printf("MAKE2 %d ",u>>16); DUMP_PISQ(PiSq);}
 return u;}

void UndoPiSqCap(type_PiSq *PiSq,uint32 mv) // must be a cap, not ep
{uint8 to=TO(mv),from=FROM(mv); int f,t,k;
 if (DEBUG) {printf("UNDO1 %d ",mv>>16); DUMP_PISQ(PiSq);}
 for (k=0;k<PiSq->n;k++) // TODO BlockedPawn
 {if (PiSq->sq[k]==to) f=k;}
 PiSq->sq[f]=from; if ((mv>>12)&7) PiSq->pi[f]=(PiSq->pi[f]<7)?wEnumP:bEnumP;
 PiSq->pi[PiSq->n]=mv>>16; PiSq->sq[PiSq->n]=to; PiSq->n++; PiSq->wtm^=1;
 PiSq->pawn=FALSE;
 for (k=0;k<PiSq->n;k++)
   if (PiSq->pi[k]==wEnumP || PiSq->pi[k]==bEnumP || PiSq->pi[k]==BlockedPawn)
     PiSq->pawn=TRUE;
 if (DEBUG) {printf("UNDO2 "); DUMP_PISQ(PiSq);}}

uint32 MakePiSqProm(type_PiSq *PiSq,uint16 mv) // must be prom, not cap
{uint32 u; uint8 to=TO(mv),from=FROM(mv); int f,t,k;
 for (k=0;k<PiSq->n;k++) {if (PiSq->sq[k]==from) f=k;}
 PiSq->pi[f]=(mv>>12)+7*!PiSq->wtm; PiSq->sq[f]=to; PiSq->wtm^=1;
 PiSq->pawn=FALSE;
 for (k=0;k<PiSq->n;k++)
   if (PiSq->pi[k]==wEnumP || PiSq->pi[k]==bEnumP || PiSq->pi[k]==BlockedPawn)
     PiSq->pawn=TRUE;
 return mv;}

void UndoPiSqProm(type_PiSq *PiSq,uint32 mv) // must be prom, not cap
{uint32 u; uint8 to=TO(mv),from=FROM(mv); int f,t,k; PiSq->wtm^=1;
 for (k=0;k<PiSq->n;k++) {if (PiSq->sq[k]==to) f=k;}
 PiSq->pi[f]=(PiSq->pi[f]<7)?wEnumP:bEnumP; PiSq->sq[f]=from; PiSq->pawn=TRUE;}

static uint8 EPtabW1[8]={B4,C4,D4,E4,F4,G4,H4,G4};
static uint8 EPtabW2[8]={B4,A4,B4,C4,D4,E4,F4,G4};
static uint8 EPtabB1[8]={B5,C5,D5,E5,F5,G5,H5,G5};
static uint8 EPtabB2[8]={B5,A5,B5,C5,D5,E5,F5,G5};
uint32 MakePiSqPlain(type_PiSq *PiSq,uint16 mv) // must be plain
{uint32 u; uint8 to=TO(mv),from=FROM(mv); int f,t,k; PiSq->wtm^=1;
 for (k=0;k<PiSq->n;k++) {if (PiSq->sq[k]==from) f=k;} PiSq->sq[f]=to;
 PiSq->ep=0;
 if (PiSq->pi[f]==wEnumP && (to-from)==16)
 {for (k=0;k<PiSq->n;k++)
   if (PiSq->pi[k]==bEnumP &&
       (PiSq->sq[k]==EPtabW1[to&7] || PiSq->sq[k]==EPtabW2[to&7]))
     PiSq->ep=to-8;}
 if (PiSq->pi[f]==bEnumP && (to-from)==-16)
 {for (k=0;k<PiSq->n;k++)
   if (PiSq->pi[k]==wEnumP &&
       (PiSq->sq[k]==EPtabB1[to&7] || PiSq->sq[k]==EPtabB2[to&7]))
     PiSq->ep=to+8;}}

void UndoPiSqPlain(type_PiSq *PiSq,uint32 mv) // must be prom, not cap
{uint32 u; uint8 to=TO(mv),from=FROM(mv); int f,t,k; PiSq->wtm^=1; PiSq->ep=0;
 for (k=0;k<PiSq->n;k++) {if (PiSq->sq[k]==to) f=k;} PiSq->sq[f]=from;}


#define Bitboard2(x, y) ((1ULL<<(x)) | (1ULL<<(y)))
const static uint64 WhiteEP[8] =
{ Bitboard2 (B4,B4), Bitboard2 (A4,C4), Bitboard2 (B4,D4), Bitboard2 (C4,E4),
  Bitboard2 (D4,F4), Bitboard2 (E4,G4), Bitboard2 (F4,H4), Bitboard2 (G4,G4)};
const static uint64 BlackEP[8] =
{ Bitboard2 (B5,B5), Bitboard2 (A5,C5), Bitboard2 (B5,D5), Bitboard2 (C5,E5),
  Bitboard2 (D5,F5), Bitboard2 (E5,G5), Bitboard2 (F5,H5), Bitboard2 (G5,G5)};

////////////////////////////////////////////////////////////////////////

char* Notate (uint32 move, char* M);
boolean MakeMove (typePOS *POSITION, uint16 mv)
{ int fr, to, pi, cp, z, y, i; char A[8]; // printf("Make %s\n",Notate(mv,A));
  memcpy (POSITION->DYN + 1, POSITION->DYN, 16);
  POSITION->DYN++; POSITION->DYN->mv = mv;
  if (POSITION->DYN->ep) POSITION->DYN->ep = 0;
  fr = FROM (mv);  to = TO (mv);
  pi = POSITION->sq[fr];
  POSITION->bitboard[pi] ^= SqSet[fr] | SqSet[to];
  if (POSITION->wtm) wBitboardOcc ^= SqSet[to] ^ SqSet[fr];
  else bBitboardOcc ^= SqSet[to] ^ SqSet[fr];
  POSITION->sq[fr] = 0;
  cp = POSITION->sq[to];
  POSITION->sq[to] = pi;
  POSITION->DYN->cp = cp;
  if (cp)
    { POSITION->bitboard[cp] ^= SqSet[to];
      if (POSITION->wtm) bBitboardOcc ^= SqSet[to];
      else wBitboardOcc ^= SqSet[to];}
  if (mv & (7 << 12)) /* prom */
    { if (POSITION->wtm) { z = wEnumP; y = mv >> 12; }
      else { z = bEnumP; y = 7 + (mv >> 12); }
      POSITION->bitboard[z] ^= SqSet[to];
      POSITION->bitboard[y] ^= SqSet[to];
      POSITION->sq[to] = y;}
  if (mv & (1 << 15)) /* ep */
    { z = to ^ 8; POSITION->sq[z] = 0;
      if (POSITION->wtm) { bBitboardOcc ^= SqSet[z]; bBitboardP ^= SqSet[z];}
      else { wBitboardOcc ^= SqSet[z]; wBitboardP ^= SqSet[z];}}
  POSITION->DYN->ep = 0;
  if (pi == wEnumP && (to - fr) == 16)
    { if (WhiteEP[to & 7] & bBitboardP)
	{ int z = (fr + to) >> 1; POSITION->DYN->ep = z;} }
  if (pi == bEnumP && (to - fr) == -16)
    { if (BlackEP[to & 7] & wBitboardP)
	{ int z = (fr + to) >> 1; POSITION->DYN->ep = z; } }
  POS->OCCUPIED = wBitboardOcc | bBitboardOcc;
  POSITION->wtm ^= 1;
  return TRUE;
}

////////////////////////////////////////////////////////////////////////

void UnmakeMove (typePOS *POSITION, uint16 mv,boolean DEL)
{
  int fr, to, pi, z; char A[8]; // printf("Undo %s\n",Notate(mv,A));
  fr = FROM (mv);  to = TO (mv);  pi = POSITION->sq[to];
  POSITION->wtm ^= 1;
  if (mv & (7 << 12))
    { POSITION->bitboard[pi] ^= SqSet[to];
      pi = POSITION->wtm ? wEnumP : bEnumP;
      POSITION->bitboard[pi] ^= SqSet[to]; }
  POSITION->sq[fr] = pi;
  POSITION->sq[to] = POSITION->DYN->cp;
  if (POSITION->wtm) wBitboardOcc ^= SqSet[to] ^ SqSet[fr];
  else bBitboardOcc ^= SqSet[to] ^ SqSet[fr];
  POSITION->bitboard[pi] ^= SqSet[to] ^ SqSet[fr];
  if (POSITION->DYN->cp)
    { if (POSITION->wtm) bBitboardOcc ^= SqSet[to];
      else wBitboardOcc ^= SqSet[to];
      POSITION->bitboard[POSITION->DYN->cp] ^= SqSet[to]; }  
  if (mv & (1 << 15))
    { z = to ^ 8;
      if (POSITION->wtm)
	{ POSITION->sq[z] = bEnumP;
	  bBitboardOcc |= SqSet[z]; bBitboardP |= SqSet[z]; }
      else
	{ POSITION->sq[z] = wEnumP;
	  wBitboardOcc |= SqSet[z]; wBitboardP |= SqSet[z]; } } 
  POS->OCCUPIED = wBitboardOcc | bBitboardOcc; POSITION->DYN--;
}
